#include "common.h"

namespace cmmn {

	double * smpl_mu1, * smpl_mu2, * smpl_sgm1, * smpl_sgm2, * smpl_rho;
	int n_data;

	//
	//								Quick Sort
	//
	//      S. Kawai (1988).  Methods of programming (in Japanese). Tokyo: Iwanami-shoten.
	//		S. Ishihata (1989). Algorithms and Data Structure (in Japanese). Tokyo:Iwanami-shoten
	//
	void qSort(double * d, int Lb, int Ub){
		if (Lb < Ub){
			int p = (Lb + Ub) / 2;
			double c = d[p];
			int i = Lb;
			int j = Ub;
			do {
				while (d[i] < c) i++;
				while (c < d[j]) j--;
				if (i <= j){
					double v = d[i];
					d[i] = d[j];
					d[j] = v;
					i++;
					j--;
				}
			} while (i <= j);
			qSort(d, Lb, j);
			qSort(d, i, Ub);
		}
		return;
	}

	double k_smoother(double x, double * samples, int N, double sgm){
		double v = 0.0;
		for (int i = 0; i < N; i++)
			if (Math::Abs(x - samples[i]) < 4 * sgm){
				v += Math::Exp(-0.5 * sqr((x - samples[i]) / sgm));
			}
		return v / (N * sgm * Math::Sqrt(2.0 * Math::Atan(1.0) * 4.0));
	}

}